CON
        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000

        SDPinBase       = 0
        
        IR_InPin        = 16
        IR_OutClockPin  = 17
        IR_OutPin       = 18
        IR_InMask       = |<IR_InPin
        IR_OutClockMask = |<IR_OutClockPin
        IR_OutMask      = |<IR_OutPin

obj
   'tv: "TV_Text"
   'kb: "keyboard"
   term: "CogOS_IO(Term)"
   sd: "fsrw"

var
  long stack[500]
  long tstcount
  long sigBuffer[257]
  long end, all

  word scr_buf
  word nObs[ 20 ]
  
  byte out
  byte fname[13]

  
pub main | timing, i, firstff, lastff, state, num, cid, fcnt, x

  term.start( 1, 1, string("IR reader",$d))
  ' waitcnt( clkfreq*10+cnt )
  ' scr_buf := tv.start(TVPinBase)
  term.str( string( "Please enter a filename (w/o ext):",13) )
  getFname
  term.str( string( "got name",13) )
  
  x:=\sd.mount( SDPinBase )
  if x<>0
    term.str( string("mount error: ") )
    term.dec( x )
    repeat
  term.str( string( "mount",13) )
  sd.popen( @fname[0],"w" ) 
  term.str( string( "open",13) )

  out:="1"
  ' don't start measurement automatically, it'll be started by
  ' print later on
  sigBuffer[0]:=0

  ' hmmm ... of course it does not need to run in a different COG
  ' just old code which survived ;o)
  cognew(print, @stack[0] )
  ' this starts the PASM code that measures the IR signal and also can
  ' playback
  cognew(@ir_rec, @sigBuffer )

  ' wait until print is exited by pushing space
  repeat until end

  ' old code ....
  'cognew(@ir_out, 0 )
  'cognew(outHiLo, @stack[50] )
  'repeat
  
  ' measurement done, so close the file and start replay 
  sd.pclose
  term.tx( 0 )
  term.str( string( "done!" ))

  ' first seek for the end of a sequence (currently identified
  ' by 1s for at least 5 longs
  state:=0
  ' loop over all samples and find the end of one sequence, the rest is overwritten
  ' with 1s (loop could also be stopped when in state 2 - but I did not remember the
  ' break instruction ;o). The long which switched to state 2 should be overwritten
  ' as it contains 0s.
  repeat i from 1 to 256
    if state==0
      if sigBuffer[i]==$ffff_ffff
        state:=1
        firstff:=i
    if state==1
      if sigBuffer[i]==$ffff_ffff
        lastff:=i
      else
        if lastff-firstff>5
          state:=2
    if state==2
      sigBuffer[i]:=$ffff_ffff
      
  timing := 0

  ' start the carrier frequency-COG
  cid:=cognew(@ir_out, 0 )
  ir_wait := 40_000_000 / (20_000 + fcnt*1000)
  

  repeat
    ' and replay the signal up to the end found above
    repeat 50
      term.tx( 0 )
      term.str( string( "sending ... " ))
      term.dec( timing++ )
      term.tx( " " )
      term.dec( 20_000 + fcnt*1000 )
      repeat while sigBuffer[0]
      ' 2 = command for sending, higher byte tells how much
      sigBuffer[0]:=2 + lastff<<8

    fcnt:=(fcnt+1)//nof
    ir_wait := 40_000_000 / (20_000 + fcnt*1000)

    coginit(cid, @ir_out, 0)
    


' awaits the filename to be entered with keyboard but without extension.
' CR or entering 8 characters ends the input.
pub getFname | i,done,pos
  pos:=0
  done:=0
  repeat until done
    i:=term.rx
    if i==13
      done:=1
    else
      fname[pos++]:=i
      term.tx( i )
      if pos==8
        done:=1
  fname[pos++]:="."
  fname[pos++]:="t"
  fname[pos++]:="x"
  fname[pos++]:="t"
  fname[pos++]:=0
  term.str( string(".txt") )
  term.tx( 13 )
  
pub print | in
  'term.str( string( "Learn Timing!!",13) )
  'sd.pwrite( string( "Timing:",$0d,$0a), 9 )
  'sd.pwrite( string( $0d,$0a ), 2 )
  
  term.str( string( "Please select the key to record!!",13) )

  ' repeat until SPACE has been entered
  repeat
    in:=0
            
    ' get the name of the key pressed and write it to file
    repeat until in==13
      in:=term.rx
      if in==" "
        end:=1
        return
      if in==208
        analyse
      else
        if in <> 13
          sd.pputc( in )
          term.tx( in )

    term.tx( 13 )
    sd.pputc( ":" )
    sd.pputc( $0d )
    sd.pputc( $0a )

    ' start the measurement and wait until COG filled the buffer
    sigBuffer[0]:=1    
    repeat while sigBuffer[0]
    analyse

    sd.pwrite( @translation, strsize( @translation ) )
    sd.pputc( $0d )
    sd.pputc( $0a )

pub analyse | i, j , state, bcnt, val, bit, ende
  bytefill(@nObs, 0, 20)

  term.str( string(13,"analysing...",13) )
  state:=0
  bcnt:=0
  ende:=0
  all:=0
  repeat i from 1 to 256
    val := sigBuffer[ i ]
    repeat j from 31 to 0
      bit := |< j
      all++
      case state
        0:
          if val&bit
            state:=1
            addList( 0, bcnt )
            bcnt:=1
          else
            bcnt++
        1:
          if val&bit
            bcnt++
            if bcnt>256
              ende:=1
          else
            state:=0
            addList( 1, bcnt )
            bcnt:=1
            if ende
              term.str( string("Total # of samples per sequence: ") )
              term.dec( all )

              printStat
              translate
              return
  printStat
  translate
   

pub printStat | i
  term.str( string(13, "Summary 0s:",13))
  repeat i from 0 to 9
    term.dec( nObs[ i<<1 ] )
    term.str( string( ", ") )
   
  term.str( string(13,"Summary 1s:",13))
  repeat i from 0 to 9
    term.dec( nObs[ i<<1 + 1] )
    term.str( string( ", ") )

pub addList( bit, nOb ) | idx, found, i, val
  idx:=0
  found:=0
  repeat while (nObs[ idx<<1 + bit ] <> 0) and (idx<10)
    if ||(nObs[idx<<1 + bit]-nOb)<3
      found:=1
      quit
    if (nObs[idx<<1 + bit]-nOb) => 3
      quit     
    idx++

  if not found
    if nObs[ idx<<1 + bit ] == 0
      'tv.str( string("append "))
      nObs[idx<<1 + bit]:=nOb
    else
      'tv.str( string("insert "))
      val:=nOb

      repeat while (nObs[ idx<<1 + bit ] <> 0) and (idx<9)
        nOb := nObs[ idx<<1 + bit ]
        nObs[ idx<<1 + bit ] := val
        val := nOb
        idx ++
        
      nObs[ idx<<1 + bit ] := val

pub translate  | i, j , state, bcnt, val, bit, ende, lall, wcnt
  term.tx( 13 )
  lall:=0
  state:=0
  bcnt:=0
  wcnt:=0
  trancnt:=0
  repeat i from 1 to 256
    val := sigBuffer[ i ]
    repeat j from 31 to 0
      bit := |< j
      lall++
      if lall>all
        term.dec( wcnt )
        term.tx(13)
        translation[ trancnt ]:=0
        term.str( @translation )
        term.tx( 13 )
        return
      case state
        0:
          if val&bit
            state:=1
            printTrans( 0, bcnt )
            wcnt++
            bcnt:=1
          else
            bcnt++
        1:
          if val&bit
            bcnt++
          else
            state:=0
            printTrans( 1, bcnt )
            wcnt++
            bcnt:=1

pub printTrans( bit, nOb ) | idx
  idx:=0
  repeat while (nObs[ idx<<1 + bit ] <> 0) and (idx<10)
    if ||(nObs[idx<<1 + bit]-nOb)<3
      if bit==0
        term.tx( lowercase[ idx ] )
        translation[ trancnt++ ]:= lowercase[ idx ]
      else
        term.tx( uppercase[ idx ] )      
        translation[ trancnt++ ]:= uppercase[ idx ]      
      quit     
    idx++
      
pub fileOut( val )
  repeat 32
    if val&$80000000
      sd.pputc( "1" )
    else
      sd.pputc( "0" )
    val<<=1
  sd.pputc( $0d )
  sd.pputc( $0a )
    
pub outHiLo | tim2
  dira[IR_OutPin]:=1

  repeat
    tim2:=cnt
    repeat 20
      tim2 += 80_000
      waitcnt( tim2 )
      !outa[ IR_OutPin ]
    outa[ IR_OutPin ]:=0
    waitcnt( clkfreq+cnt )  

dat
nof       long 600

lowercase byte "abcdefghij"
uppercase byte "ABCDEFGHIJ"

translation byte 0[256]
trancnt     byte 0

' This one generates the ~33kHz carrier signal.
' Maybe a counter can do the job later on.
dat
  org 0

tim
ir_out        or        dira, ir_clk_mask
              mov       tim, cnt
              add       tim, ir_wait

da_lp         waitcnt   tim, ir_wait
              xor       outa, ir_clk_mask
              jmp       #da_lp

ir_clk_mask   long      IR_OutClockMask
ir_wait       long      80_000_000 / 33_000 / 2


' measure- , translate- and replay-code
dat
        org 0

ir_rec        rdlong    ir_smpl_buf, par WZ
        if_z  jmp       #ir_rec

              mov       cur, ir_smpl_buf
              and       cur, #$ff

              cmp       cur, #1 WZ
        if_z  jmp       #read
              cmp       cur, #2 WZ
        if_z  jmp       #send
              wrlong    zero, par
              jmp       #ir_rec
read
              movd      store, #ir_smpl_buf

              waitpeq   ir_in_mask, ir_in_mask
              waitpne   ir_in_mask, ir_in_mask
              mov       bitcnt, #32
              mov       longcnt, #256
              test      ir_in_mask, ina WC
        if_c  jmp       #read
        
              mov       tcnt, cnt
              add       tcnt, ir_smpl_time
              jmp       #rollin

lp            mov       bitcnt, #32
lp2           waitcnt   tcnt, ir_smpl_time
              test      ir_in_mask,ina WC
rollin        rcl       cur, #1

              djnz      bitcnt, #lp2
store         mov       0-0,cur
              add       store, wroffset

              djnz      longcnt, #lp

              mov       longcnt, #256
              movd      wrlo, #ir_smpl_buf
              mov       wradr, par
              add       wradr, #4
wrlo
              wrlong    ir_smpl_time, wradr
              add       wradr, #4
              add       wrlo, wroffset
              djnz      longcnt, #wrlo

              wrlong    zero, par
              jmp       #ir_rec

send
              or        dira, ir_out_mask
              ' reverse, if
              or        outa, ir_out_mask
                            
              mov       sendcnt, ir_smpl_buf
              shr       sendcnt, #8
              mov       longcnt, sendcnt

              movd      sndlo, #ir_smpl_buf
              mov       wradr, par
              add       wradr, #4
sndlo
              rdlong    0-0, wradr
              add       wradr, #4
              add       sndlo, wroffset
              djnz      longcnt, #sndlo

lddone
              movs      load, #ir_smpl_buf
              mov       tcnt, cnt
              add       tcnt, ir_smpl_time
              mov       longcnt, sendcnt

load          mov       cur, 0-0

slp           mov       bitcnt, #32
slp2          rcl       cur, #1 WC
              waitcnt   tcnt, ir_smpl_time
      if_nc    or        outa, ir_out_mask
      if_c   andn      outa, ir_out_mask

              djnz      bitcnt, #slp2
              add       load, #1
              djnz      longcnt, #load

              andn      dira, ir_out_mask
              wrlong    zero, par
              jmp       #ir_rec
              
cur           long      1
bitcnt        long      0
tcnt          long      0
longcnt       long      0
sendcnt       long      0
wradr         long      0
zero          long      0         
ir_in_mask    long      IR_InMask
ir_out_mask   long      IR_OutMask
ir_smpl_time  long      4_000
wroffset      long      %1000000000
ir_smpl_buf   long      0 [256]

              fit       492                         